"""
Pekara Kiflica proizvodi hleb i kifle. Za mešenje hleba potrebno je 10 minuta,
dok je za kiflu potrebno 12 minuta. Vreme potrebno za pečenje ćemo zanemariti. Testo za hleb
sadrži 300g brašna, a testo za kiflu sadrži 120g brašna. Zarada koja se ostvari prilikom prodaje
jednog hleba je 7 dinara, a prilikom prodaje jedne kifle je 9 dinara. Ukoliko pekara ima 20 radnih
sati za mešenje peciva i 20kg brašna, koliko komada hleba i kifli treba da se umesi kako bi se
ostvarila maksimalna zarada (pod pretpostavkom da će pekara sve prodati)?

"""
"""
H - KOLICINA HLEBOVA, KOLIKO HLEBOVA IMAMO
K - KOLICINA KIFLI, -||-

za 1 hleb nam treba 10min
za 1 kiflu nam treba 12min
20h
H*10 + K*12 <= 20h= 20*60 =1200

za 1 hleb nam treba 300g
za 1 kiflu nam treba 120g
20kg
H*300 + 120*K <=20kg = 20*1000 = 20000

H, K >=0

7*H + 9*K maksimizujemo

ako imamo samo hleb:
1200/10  = 120 najvise za vreme
20000/300 = 67 najvise za brasno

ako imamo samo kiflice:
1200/12 = 100 najvise za vreme
20000/120 = 167 najvise za brasno
 H >=0, H<=67
 K >=0, K<=100

"""

problem = constraint.Problem()
problem.addVariable("H", range(1, 68))
problem.addVariable('K', range(1, 101))

def o_vreme(h, k):
  if 10*h + 12*k <= 1200:
    return True
def o_brasno(h, k):
  if 300*h + 120*k<=20000:
    return True

problem.addConstraint(o_vreme,"HK")
problem.addConstraint(o_brasno, "HK")
resenja = problem.getSolutions()
max_H = max_K = -1
max_zarada = 0
for r in resenja:
  if r['H']*7 + r['K']*9 > max_zarada:
    max_zarada = r['H']*7 + r['K']*9
    max_H = r['H']
    max_K = r['K']

print("-----------------------------")
print(
    "Maksimalna zarada je {0:d}, komada hleba je {1:d}, komada kifli je {2:d}".
    format(max_zarada, max_H, max_K))
print("-----------------------------")

6
